#!/opt/rational/clearcase/bin/Perl 

### ------------------------------------------------------------------
### | Copyright Unpublished, Pure Atria.           All Rights        |
### | Reserved.  This software contains proprietary and confidential |
### | information of Atria and its suppliers.  Use, disclosure or    |
### | reproduction is prohibited without the prior express written   |
### | consent of Atria.                                              |
### ------------------------------------------------------------------
###

###
### clearapropos
###

# This script implements the apropos command for several CLi tools.
# This command searches the ref-page title lines, which
# are stored in the main "whatis" database.
# Glossary mode is no longer supported. 

#------------------------------------------------------------------
# setup
#

	$datestamp	= "17-Dec-1998";
	$Progn		= &Leaf($0);
	$Ahome		= $ENV{CLEARCASEHOME} || $ENV{ATRIAHOME} || "/opt/rational/clearcase";

#------------------------------------------------------------------
# establish array of database filenames
#

	
	if ($Progn eq "clearapropos") {
		$whatis_db	= $ENV{CC_WHATIS_DB}	|| "$Ahome/doc/man/cc_whatis";
	} elsif ($Progn eq "multiapropos") {
		$whatis_db	= $ENV{MS_WHATIS_DB}	|| "$Ahome/doc/man/ms_whatis";
	} elsif ($Progn eq "clearguide_apropos") {
		$whatis_db	= $ENV{CG_WHATIS_DB}	|| "$Ahome/doc/man/cg_whatis";
	} else {
		die "$Progn: This script must be invoked under\nthe name 'clearapropos', 'multiapropos', or 'clearguide_apropos'\n";
	}

#------------------------------------------------------------------
# check for flags (none currently permitted)
#

	$opt = shift;

	### not an option if it doesn't begin with "-",
	### so put it back on argument array
	if (substr($opt,0,1) ne "-") {
		unshift(@ARGV,$opt);
	}

	### it's an option, fail
	else {
	    die "$Progn: invalid command-line option '$opt'\n";
	}

#------------------------------------------------------------------
# search through database
#

	### create regexp search string from all arguments
	
        $searchstr      = join "|",@ARGV;
	
	### search the standard database
	
	open(IN,$whatis_db)
		|| die "$Progn: could not open file '$whatis_db'\n";
	while (<IN>) {
		print if /$searchstr/i;
	}
	close(IN);

#------------------------------------------------------------------
# cleanup and exit
#

	exit 0;


#------------------------------------------------------------------
# Leaf -- return leaf of pathname (either ".../..." or "...\...")
#
# arg0 = string to be processed

sub Leaf {
	if ($_[0] =~ m@.*[/\\](.*)$@) {
		$1;
	} else {
		$_[0];
	}
}
